{
=============================================================================
| THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"  |
| AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE    |
| IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   |
| ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR  |
| ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL       |
| DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR   |
| SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER   |
| CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT           |
| LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY    |
| OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH  |
| DAMAGE.                                                                      |
=============================================================================
   Author:  D.J.C. Blijker.
   Date:    27-4-2003
   version: 1.0
   e-mail:  c.blijker@wxs.nl
-----------------------------------------------------------------------------
  This program serves just as a very simple example of an implementation of
  a TCP-Server.
  On startup this program starts listening at localhost on port 3003.
  Everything sent to this program by a (blocking)tcp-client is sent back
  immediately. (This program is the counter part of the BlockingTcpClient
  example)
=============================================================================
}
unit TcpServer_Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,

  HxDataExchange, HxTcpIpcUdp;

type
  TForm4 = class(TForm)
    mmo: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    de: THxDataExchange;
    tcpServ: THxTcpServer;
    procedure HandleData(ptr: pointer; iSize, iDescr: integer);
    procedure ShowClientExit(iDescr: integer);
    procedure ShowNewClient(iDescr: integer);
  public
    { Public declarations }
  end;

var
  Form4: TForm4;

implementation

{$R *.DFM}

procedure TForm4.FormCreate(Sender: TObject);
begin
  de := THxDataExchange.Create;

  tcpServ := THxTcpServer.Create;
  tcpServ.OnDataAvailable := HandleData;
  tcpServ.Port := '3003';
  tcpServ.OnNewClient := ShowNewClient;
  tcpServ.OnClientAborted := ShowClientExit;
  tcpServ.Listen;

end;

procedure TForm4.FormDestroy(Sender: TObject);
begin
  de.Free;
  tcpServ.Free;
end;

procedure TForm4.HandleData( ptr: pointer; iSize, iDescr: integer );
var
  s: string;
begin
  de.ReadString( ptr, s );
  mmo.Lines.Add( s );
  tcpServ.SendString( s, iDescr );
end;

procedure TForm4.ShowNewClient( iDescr: integer );
begin
  mmo.Lines.Add( Format('New client with descriptor: %d', [iDescr] ));
end;

procedure TForm4.ShowClientExit( iDescr: integer );
begin
  mmo.Lines.Add( Format('Client with descriptor: %d logged off', [iDescr] ));
end;

end.
